﻿	/************************************************************ 
	/ Auteurs : DELOISON Matthieu								/ 
	/ Fonction : CV en flash 8									/
	/															/
	/ Date de création : 07/02/2006  							/
	/ Date de mise à jour : --/--/200-	 						/ 
	************************************************************/
	

// on fait tous les import nescessaires
import com.delfiweb.utils.LoadStack;
import com.delfiweb.utils.AppelFct;
import com.delfiweb.command.Delegate;
import com.delfiweb.command.AppelURLCommand;
import com.delfiweb.error.*;
// effets
import flash.filters.BlurFilter;
import flash.display.BitmapData;
import flash.filters.DisplacementMapFilter;

import flash.geom.Transform;
import flash.geom.Matrix;
import flash.geom.Point;



/**
* Point d'entrée du programme
* 
* @class PMain
* @author Claude François
* @version 0.1
*/
class PMain
{
	private static var _instance:PMain;	// L'instance unique du singleton
	public var isLocal:Boolean;		// Est-t'on en local ?
	public var isDebug:Boolean;		// Active-t'on le debug ?
	public var _main:MovieClip;		// Pointeur sur le niveau	
	//private var _pDial:MovieClip;				// la boite de dialogue
	private var _voile:MovieClip;				// Voile d'opacité
	
	/*--------- Composants de la scène ---------*/
	private var _photo:MovieClip;
	private var _fondecran:MovieClip;
	private var loadering:MovieClip;
	private var loadingQueue;
	public var _parser;
	
	
	/*--------- variables globales ---------*/
	private var _niveau:Number;		// niveau des Movie Clip sur la scène
	private var _monXML:XML;

	/*--------- effet de vagues ---------*/	
	private var _mcCible_xDecal  
	private var _mcCible_yDecal    
	private var _activVagues     
	private var _inter
	private var _vaguesData:BitmapData
	private var _lancerEffects:Boolean;
	
	
	/*--------- effet de flammes ---------*/
	private var _flammes:BitmapData;
	private var _flammes2:BitmapData;
	private var _flammes_xDeplac;
	private var _flammes_yDeplac;
	private var flamme:MovieClip;
	private var flamme2:MovieClip;
	private var _interF;
	
	
	/*--------- constantes ---------*/
	private var _appel;
	private var _timeOut;
	
	
	
	/**
	* Constructeur privé, réalise la plupart des initialisations du programme, appelle ensuite
	* la méthode <b>_init</b> qui est la fonction de lancement autonome du programme, à utiliser
	* avec le PGameController
	* 
	* @method PMain 
	* @return Void
	*/
	private function PMain ()
	{
		// si le parametre version n'est pas transmis on est en local
		isLocal = (_root.version == undefined) ? true : false;
		// si on est en local le debug est donc activé, sinon c'est en fonction du parametre php
		isDebug = (isLocal) ? true : ((_root.debug != undefined) ? true : false);
		// si on est en local on définit les variables qui nous sont nécessaires
		
		
		//isLocal = true;
		//isLocal = false;
		
		if (isLocal)
		{
			// si on est en local on diffuse toutes les erreurs possible
			//ErrorDispatcher.FILTER = 5;
			_root.ficxml="donnees.xml";
		}
		// on s'inscrit comme écouteur du diffuseur d'erreur
		//ErrorDispatcher.addListener (this);

		// on stocke les pointeurs
		_main = _root;

		
	}
	
	
	/**
		* C'est le point d'entrée du programme, appelé sur la première image du fla,
		* elle est compatible MTASC
		* 
		* @usage	PMain.main()
		* @method 	static main
		* @return 	Void
		*/
	public static function main ()
	{
		instance._init();
	}
	
	
	/**
		* C'est la qu'on fera le vrai setup du programme, prévue pour une utilisation avec 
		* le nouveau Debugger
		* 
		* @usage 	PMain.instance._init()
		* @method 	_init
		* @return 	Void
		*/
	public function _init ()
	{	
		if (!_voile)
		{
			_voile = _main.attachMovie ("voile", "voile", 3000);
			_parser = Parser.getInstance();
		}
		_main = _root.createEmptyMovieClip("contenair",_niveau++)
		//_pDial.alert (_global.Strings[1]+"<br /><img hspace='25' vspace='10'  src=\"loadering2\" id=\"loadering\">");
		//_pDial.alert (_global.Strings[1]+"<br /><img hspace='25' vspace='10'  src=\"loaderHorl\" id=\"loadering\">");
		_lancerEffects = false;
		_niveau = 10; // permet d'attacher 
		//_main.FPSCounter.swapDepths(1003);
		onVisibleChange(true);
		jouer();

	}
	
	/**
	 *	Appelé par la PUFBox cette fonction lance tout d'abord la vérification
	 *  de doublon flash
	 * 
	 *	@usage		PMain.instance.jouer()
	 *	@method		jouer
	 *	@return		Void
	 */
	public function jouer ()
	{
		jouerOn ();
	}
	
	/**
	 *	Appelé si aucune instance du flash n'existe 
	 * 
	 *	@usage		jouerOn()
	 *	@method		jouerOn
	 *	@return		Void
	 */
	public function jouerOn ()
	{
		/*--- Charge/Décode le xml ---*/
		chargeXML();
		/*
		constructCV();
		*/
		
	}
	
		
	/**
	* @property instance (PMain) L'instance unique de la classe PMain (read-only)
	*/
	public static function get instance ():PMain
	{
		if(_instance == undefined)
		{
			_instance = new PMain();			
		}
		return _instance;
	}
	
	
	/*---------------------------------------------------------------*/
	/*--------------- Construction CV -------------------------------*/
	/*---------------------------------------------------------------*/
	
	function constructCV()
	{
		_main.attachMovie ("bordure", "bordure", _niveau++,{_visible:false});
		affichage();
		cvHeader();
		cvFormations();
		cvExperiences();
		cvConnaissances();
		cvLoisirs();
		persoMenu();
		
		onVisibleChange(false);
		
		effectFlou()
	}
	
	
	function affichage()
	{
		_fondecran = _main.createEmptyMovieClip("fondecran", _niveau++ );
		_main.attachMovie ("fondPhoto", "fondPhoto", _niveau++, {_x:779, _y:11}); // l'image de fond

		_photo = _main.createEmptyMovieClip("photo", _niveau++ );
		
		loadingQueue = new LoadStack ();
		loadingQueue.addListener (this);
		
		loadingQueue.loadClip ("images/photo-petite.jpg", _photo);
		loadingQueue.startLoad ();
		
	}
	
	
	
	
	// fonction : traduit le cv en fr
	function _onClikFR()
	{
		_root.ficxml = _root.ficxmlfr;
		buildCV();
	}
	
	
	// fonction : traduit le cv en en
	function _onClikEN()
	{
		_root.ficxml = _root.ficxmlen;
		buildCV();
	}
	
	
	
	// entrée : rien
	// fonction : construit le haut du cv
	function cvHeader()
	{	
		// le titre du cv.
		_main.attachMovie ("titre", "titre", _niveau++, {_x:160, _y:30}); // l'image de fond
		_main.titre.contenu = _global.Strings[11];

		_main.attachMovie ("nom", "nom", _niveau++, {_x:20, _y:11}); // l'image de fond
		_main.nom.contenu = _global.Strings[12];
		
		_main.attachMovie ("description", "adresse", _niveau++, {_x:20, _y:38});
		_main.adresse.contenu = _global.Strings[13];
		
		_main.attachMovie ("description", "telephone", _niveau++, {_x:20, _y:87});
		_main.telephone.contenu = _global.Strings[14];
		
		_main.attachMovie ("description", "telephone2", _niveau++, {_x:20, _y:100});
		_main.telephone2.contenu = _global.Strings[15];
		
		_main.attachMovie ("email", "email", _niveau++, {_x:20, _y:115});
		_main.email.contenu = "<b>"+_global.Strings[16]+"</b>";
		_main.email.onRelease = function()
		{
			// redirection sur le site
			var obj:Object=""; 
			var command = new AppelURLCommand ("mailto:"+_global.Strings[16],"_self", "GET", {}).execute();
			command.execute ();
		}
		
		
		
		_main.attachMovie ("description", "complement", _niveau++, {_x:20, _y:130});
		_main.complement.contenu = _global.Strings[17];
		
		/*--- pdf ---*/
		_main.attachMovie ("email", "email3", _niveau++, {_x:670, _y:158});
		_main.email3.contenu = _global.Strings[70];
		_main.email3.onRelease = function()
		{
			// redirection sur le site
			var obj:Object=""; 
			var command = new AppelURLCommand (_global.Strings[81],"_blank", "GET", {}).execute();
			command.execute ();
		}
		
		
		
		/*--- version en ---*/
		_main.attachMovie("Buttons","Buttons2",_niveau++,{_x:463, _y:150})
		_main.Buttons2._x = 495;
		_main.Buttons2._y = 187;
		_main.Buttons2._rotation  = 180;
		_main.Buttons2.onRelease = Delegate.create(this,_onClikEN).getFunction()
		
		
		/*--- version fr ---*/
		_main.attachMovie("Buttons","Buttons1",_niveau++,{_x:390, _y:150})
		_main.Buttons1._x = 390;
		_main.Buttons1._y = 150;
		_main.Buttons1.onRelease = Delegate.create(this,_onClikFR).getFunction()
		
		
		/*--- version fr ---*/
		_main.attachMovie ("email", "email30", _niveau++, {_x:317, _y:158});
		_main.email30.contenu = _global.Strings[75];
	

		/*--- version en ---*/
		_main.attachMovie ("email", "email20", _niveau++, {_x:500, _y:158});
		_main.email20.contenu = _global.Strings[76];

		
	}
	
	
	// fonction : bloc formation du cv
	function cvFormations()
	{
		// entête
		_main.attachMovie ("titreCategorie", "titreCategorie1", _niveau++, {_x:Constant.TITRESOULIGNE, _y:_main.email30._y+_main.email30._height+15});
		_main.attachMovie ("titreCategorieS", "titreCategorieS1", _niveau++, {_x:Constant.TITRE, _y:_main.email30._y+_main.email30._height+15});
		_main.titreCategorieS1.contenu = _global.Strings[21];
				
		// champ des années
		_main.attachMovie ("annee", "annee1", _niveau++, {_x:Constant.TITRESOULIGNE, _y:_main.titreCategorieS1._y+_main.titreCategorieS1._height});
		_main.annee1.form.styleSheet = _global.$_CSS;
		_main.annee1.form.autoSize = true;
		_main.annee1.contenu = _global.Strings[22];
		
		// champ descriptions
		_main.attachMovie ("description", "description1", _niveau++, {_x:Constant.DESCRIPTION, _y:_main.annee1._y});
		_main.description1.form.styleSheet = _global.$_CSS;
		_main.description1.form.autoSize = true;
		_main.description1.contenu = _global.Strings[23];

	}
	
	
	
	// fonction : bloc expérience du cv
	function cvExperiences()
	{
		// entête
		_main.attachMovie ("titreCategorie", "titreCategorie2", _niveau++, {_x:Constant.TITRESOULIGNE, _y:_main.description1._y+_main.description1._height});
		_main.attachMovie ("titreCategorieS", "titreCategorieS2", _niveau++, {_x:Constant.TITRE, _y:_main.description1._y+_main.description1._height});
		_main.titreCategorieS2.contenu = _global.Strings[31];
		
		// champ des années
		_main.attachMovie ("annee", "annee4", _niveau++, {_x:Constant.TITRESOULIGNE, _y:_main.titreCategorieS2._y+_main.titreCategorieS2._height});
		_main.annee4.form.styleSheet = _global.$_CSS;
		_main.annee4.form.autoSize = true;
		_main.annee4.contenu = _global.Strings[32];
		
		// champ descriptions
		_main.attachMovie ("description", "description4", _niveau++, {_x:Constant.DESCRIPTION, _y:_main.annee4._y});
		_main.description4.form.styleSheet = _global.$_CSS;
		_main.description4.form.autoSize = true;
		_main.description4.contenu = _global.Strings[33];
	
	}
	
	
	// fonction : bloc connaissances du cv
	function cvConnaissances()
	{
		
		// entête
		_main.attachMovie ("titreCategorie", "titreCategorie3", _niveau++, {_x:Constant.TITRESOULIGNE, _y:_main.description4._y+_main.description4._height});
		_main.attachMovie ("titreCategorieS", "titreCategorieS3", _niveau++, {_x:Constant.TITRE, _y:_main.description4._y+_main.description4._height});
		_main.titreCategorieS3.contenu = _global.Strings[51];
		
		// champ des années
		_main.attachMovie ("annee", "annee10", _niveau++, {_x:Constant.TITRESOULIGNE, _y:_main.titreCategorieS3._y+_main.titreCategorieS3._height});
		_main.annee10.form.styleSheet = _global.$_CSS;
		_main.annee10.form.autoSize = true;
		_main.annee10.contenu = _global.Strings[52];
		
		// champ descriptions
		_main.attachMovie ("description", "description10", _niveau++, {_x:Constant.DESCRIPTION, _y:_main.annee10._y});
		_main.description10.form.styleSheet = _global.$_CSS;
		_main.description10.form.autoSize = true;
		_main.description10.contenu = _global.Strings[53];
	
	}
	
	
	// fonction : bloc loisirs du cv
	function cvLoisirs()
	{
		
		// entête
		_main.attachMovie ("titreCategorie", "titreCategorie4", _niveau++, {_x:Constant.TITRESOULIGNE, _y:_main.description10._y+_main.description10._height});
		_main.attachMovie ("titreCategorieS", "titreCategorieS4", _niveau++, {_x:Constant.TITRE, _y:_main.description10._y+_main.description10._height});
		_main.titreCategorieS4.contenu = _global.Strings[61];
		
		// champ des années
		_main.attachMovie ("annee", "annee12", _niveau++, {_x:Constant.TITRESOULIGNE, _y:_main.titreCategorieS4._y+_main.titreCategorieS4._height});
		_main.annee12.form.styleSheet = _global.$_CSS;
		_main.annee12.form.autoSize = true;
		_main.annee12.contenu = _global.Strings[62];
		
		// champ descriptions
		_main.attachMovie ("description", "description12", _niveau++, {_x:Constant.DESCRIPTION, _y:_main.annee12._y});
		_main.description12.form.styleSheet = _global.$_CSS;
		_main.description12.form.autoSize = true;
		_main.description12.contenu = _global.Strings[63];
	
		_main.bordure._height = _main.description12._y+_main.description12._height+10;
		_main.bordure._visible = true;
	
	}
	
	
	/*---------------------------------------------------------------*/
	/*--------------- Traitement du fichier XML ---------------------*/
	/*---------------------------------------------------------------*/
		
	
	// fonction : charge le fichier xml
	function chargeXML()
	{
		_monXML = new XML();
		_monXML.ignoreWhite = true;
		//_root._monXML.onLoad = Delegate.create(this,parseXML);
		_monXML.onLoad = function()
		{
			PMain.instance._parser.parseXML(PMain.instance._monXML)
		}
		
		var aleatoire = 10 * random(1500);
		var nomTemp:Number = random(25);
		if(isLocal) _monXML.load(_root.ficxml);// on lance le chargement
		else _monXML.load(_root.ficxml+"?cacheKill"+nomTemp+"="+aleatoire);// on lance le chargement
		

	}
	
	
	
	// reconstruit le cv en fonction de la langue choisie
	function buildCV()
	{
		_main.removeMovieClip();
		_niveau = 10; // permet d'attacher 
		_main = _root.createEmptyMovieClip("contenair",_niveau++)
		onVisibleChange(true);
		jouer();
	}
	
	
	
	
	/*---------------------------------------------------------------*/
	/*--------------------- Effect CV -------------------------------*/
	/*---------------------------------------------------------------*/
	
	
	// fonction : effet de flou sur tout le cv
	function effectFlou()
	{
		/*--- effet de flou ---*/
		var blur:BlurFilter  = new BlurFilter(4, 4, 3);			
		_main.filters = [blur];
		_appel = new Delegate(this,_finCV);
		_timeOut = new AppelFct (_appel,Constant.DELAIFINBLUR);
		
	}
	
	
	// fonction : effet de vagues sur le titre du cv
	function effectVagues()
	{
		_vaguesData = new BitmapData(_main.titre._width, _main.titre._height, false, 0x0066ff);
		//_vaguesData = new BitmapData(100, 100, false, 0x0066ff); // sur la photo

		var mcCible:MovieClip = _main.createEmptyMovieClip("contenair-vagues", _niveau++);
		mcCible.attachBitmap(_vaguesData, _niveau++);
		mcCible._visible = false;
		mcCible._x = 0;
		_mcCible_xDecal = 0;
		_mcCible_yDecal = 0;
		
		_onEffectV();		
	}
	
	
	function creaVag() 
	{
		_mcCible_xDecal += 0.5;
		_mcCible_yDecal -= 5;
		var myPoint = new Point(_mcCible_xDecal, _mcCible_yDecal);
		_vaguesData.perlinNoise(300, 25, 3, 5, false, true, 4, false, myPoint);
		creaDisplacementMap();
	}
	
	
	function creaDisplacementMap():Void 
	{
		var filter:DisplacementMapFilter = new DisplacementMapFilter(_vaguesData, new Point(0, 0), 4, 4, 20, 20, "wrap");
		_main.titre.filters = [filter];
		//_photo.filters = [filter];
	}
	
	function _onEffectV() 
	{
		(_activVagues) ? stopVagues() : jouerVagues();
		_activVagues =! _activVagues;
	}
	

	function stopVagues() 
	{
		clearInterval(_inter);
	}
	
	function jouerVagues() 
	{
		_inter = setInterval(this, "creaVag", 123);
	}

	
	
	// fonction : ajoute un masque flouté sur la photo
	function photoFlou()
	{
		var clipCible:MovieClip = _photo;
		//_main.nom
		//creation d'un clip servant de masque
		var maskFlou:MovieClip = _main.createEmptyMovieClip("masque-photo", _niveau++);
		maskFlou.beginFill(0x000000, 100);
		maskFlou.moveTo(10, 0);
		maskFlou.lineTo(clipCible._width-10, 10);
		maskFlou.lineTo(clipCible._width-10, clipCible._height-10);
		maskFlou.lineTo(10, clipCible._height-10);
		maskFlou.lineTo(10, 10);
		maskFlou.endFill();
		
		//positionnement du clip
		maskFlou._x = clipCible._x;
		maskFlou._y = clipCible._y;
		//creation d'une instance de la classe BlurFilter
		var blur:BlurFilter = new BlurFilter(8, 8, 5);//(blurX:Number=10, blurY:Number=10, quality:Number=10)
		
		//ciblage du clip à flouter
		maskFlou.filters = [blur];//rajouter des crochets autour de blur
		//img est le nom d'occurence du clip sur la scene à masquer
		
		//creation d'une representation bitmap de notre movieclip
		clipCible.cacheAsBitmap = true;//tres important !
		
		//on masque le clip img avec le clip maskFlou
		clipCible.setMask(maskFlou);
	}

	
	// function : ajoute des flammes sur le cv
	function effectFlammes()
	{
		flamme = _main.Buttons1;
		flamme2 = _main.Buttons2;
		
		_flammes = new BitmapData(flamme._width+80, flamme._height+50, false, 0x000000FF);
		_flammes2 = new BitmapData(flamme2._width+80, flamme2._height+50, false, 0x000000FF);
		
		var clip:MovieClip = _main.createEmptyMovieClip("contenair-flammes", _niveau++);
		clip.attachBitmap(_flammes, _niveau++);
		clip._visible = false;
		
		var clip2:MovieClip = _main.createEmptyMovieClip("contenair-flammes2", _niveau++);
		clip2.attachBitmap(_flammes2, _niveau++);
		clip2._visible = false;
		
		_flammes_xDeplac = 0;
		_flammes_yDeplac = 0;
		
		_interF = setInterval(this, "creaFlammes", 50);
		var blur:BlurFilter = new BlurFilter(5, 10);
	}
	
	
	function creaFlammes():Void 
	{
		_flammes_xDeplac += 0.5;
		_flammes_yDeplac += 10;
		var pt = new flash.geom.Point(_flammes_xDeplac, _flammes_yDeplac);
		_flammes.perlinNoise(70, 60, 1, 10, false, true, 8, true, pt);
		_flammes2.perlinNoise(70, 60, 1, 10, false, true, 8, true, pt);
		creaDisplacementFlammes();
	}
		
		
	function creaDisplacementFlammes():Void 
	{
		var filter:DisplacementMapFilter = new DisplacementMapFilter(_flammes, new Point(0, 0), 1, 1, 25, 5, "clamp");
		//flamme.filters = [blur, filter];
		flamme.filters = [ filter];
		flamme2.filters = [ filter];
	}
		
		
	// fonction : enlève l'effet de flou et ajout des autres effets
	// finalise le cv
	function _finCV()
	{
		/*--- enlève effet de flou ---*/
		var blur:BlurFilter  = new BlurFilter(0, 0, 0);
		_main.filters = [blur];
		
		if( !_lancerEffects )
		{
			_lancerEffects = true;
			effectVagues();
			effectFlammes();
		}
		photoFlou();
		_main.attachMovie("effet-eau", "effet-eau",_niveau++, {_x:780, _y:660});
	}


	
	/*---------------------------------------------------------------*/
	/*--------------------- Copyright -------------------------------*/
	/*---------------------------------------------------------------*/
		
	// fonction : personalisation du menu flash
	function persoMenu()
	{
		//Debugger.output("perso menu")
		Stage.showMenu = true;
		var menuPerso:ContextMenu = new ContextMenu()

		menuPerso.hideBuiltInItems(); // cacher le menu d'origine
		
		var m1:ContextMenuItem = new ContextMenuItem("Contact", Delegate.create(PMain.instance,_mail).getFunction())
		//var m2:ContextMenuItem = new ContextMenuItem("Book", function(){})
		
		//m2.separatorBefore = true;// insérer une séparation
		
		menuPerso.customItems = [m1];
		//menuPerso.customItems = [m1,m2];
		_root.menu = menuPerso; // mettre à jour le menu
	}
	
	
	// fonction : personnalisation du menu flash - contact me
	function _mail() 
	{
		new AppelURLCommand ("http://www.delfiweb.com","_blank", "GET", {nocache:random(100)}).execute();		
	}
	
	
	
	/*---------------------------------------------------------------*/
	/*------------------------ Divers -------------------------------*/
	/*---------------------------------------------------------------*/
	
	function onLoadStart ()
	{
		_photo._visible = _fondecran._visible = false;
		_photo._x = 785;
		_photo._y = 17;
		_fondecran._y = 182;
		_fondecran._alpha = 0;
	}
	
	
	function onLoadComplete()
	{
		_main.loadering.unloadMovie();
		_photo._visible = _fondecran._visible = true;
		_fondecran._alpha = 30;
		new mx.transitions.Tween (_fondecran, "_alpha" , mx.transitions.easing.Regular.easeIn, 0, 30, 10, true )

	}
	
	
	function onLoadProgress()
	{
		/*var clip = _test["__txt"].loadering;
		clip.percentOn(loadingQueue.currentRate);*/
	}
	
	
	// fonction : permet de masquer le voile en fonction de la PDiag
	function onVisibleChange (b)
	{
		_voile._visible = b;
		if (b)
		{
			_root.attachMovie("loaderHorl","loaderHorl",4000,{_x:450,_y:300});
			_root.loaderHorl.contenu = _global.Strings[1];
			_voile.useHandCursor = false;
			_voile._alpha = 100;
					
			_voile.onRelease = function ()
			{
			};
		} 
		else
		{
			_voile.useHandCursor = false;
			_root.loaderHorl.removeMovieClip();
									
			delete _voile.onRelease
		}
		
	}

}
